// DARTH MAUL! evil Sith apprentice from Star Wars - Episode I: The Phantom Menace. Double Bladed Lightsaber is his trademark.

/* CVARS - copy and paste to shconfig.cfg

//Darth Maul
darth_level 6
darth_healpoints 10			// the #of HP healed per second
darth_knifespeed 400		// speed of Darth Maul in knife mode
darth_knifemult 2.70		// multiplier for knife damage...

*/

/*
* v1.2 - vittu - 6/19/05
*      - Minor code clean up.
*      - Added p_ knife model.
*
* v1.1 - vittu - 12/21/04
*      -SH mod 1.17.6 and up only
*      -Model name and location changed (to follow new standard)
*      -Also only needed one of the models not both (deleted useless second model)
*      -Now heals past 100hp if you have more
*      -Fixed extra speed to use knife
*
*   Darth Maul based on {HOJ}Batman's wolverine hero which is where most of the credit should go
*/

#include <amxmod>
#include <Vexd_Utilities>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="Darth Maul"
new bool:gHasDarthMaulPowers[SH_MAXSLOTS+1]
new gPlayerMaxHealth[SH_MAXSLOTS+1]
new gHealPoints
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Darth Maul", "1.2", "Chivas2973")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("darth_level", "6")
	register_cvar("darth_healpoints", "10")
	register_cvar("darth_knifespeed", "400")
	register_cvar("darth_knifemult", "2.70")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Sith Lightsaber & Regen", "Get a Sith Double Bladed Lightsaber with more damage and speed. Also regenerate HP.", false, "darth_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("darth_init", "darth_init")
	shRegHeroInit(gHeroName, "darth_init")

	// EVENTS
	register_event("ResetHUD", "newSpawn", "b")
	register_event("CurWeapon", "weaponChange", "be", "1=1")
	register_event("Damage", "darth_damage", "b", "2!0")

	// HEAL LOOP
	set_task(1.0, "darth_loop", 0, "", 0, "b")

	// Let Server know about Darth Maul's Varibles
	shSetMaxSpeed(gHeroName, "darth_knifespeed", "[29]")
	register_srvcmd("darth_maxhealth", "darth_maxhealth")
	shRegMaxHealth(gHeroName, "darth_maxhealth")
	gHealPoints = get_cvar_num("darth_healpoints")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_model("models/shmod/darthmaul_knife.mdl")
	precache_model("models/shmod/darthmaul_p_knife.mdl")
}
//----------------------------------------------------------------------------------------------
public darth_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)

	gPlayerMaxHealth[id] = 100

	if ( is_user_alive(id) ) {
		if ( hasPowers ) {
			switchmodel(id)
		}
		// This gets run if they had the power but don't anymore
		else if ( !hasPowers && gHasDarthMaulPowers[id] ){
			shRemSpeedPower(id)
		}
	}

	// Sets this variable to the current status
	gHasDarthMaulPowers[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public newSpawn(id)
{
	if ( shModActive() && gHasDarthMaulPowers[id] && is_user_alive(id) ) {
		new clip, ammo, wpnid = get_user_weapon(id, clip, ammo)
		if (wpnid != CSW_KNIFE && wpnid > 0) {
			new wpn[32]
			get_weaponname(wpnid, wpn, 31)
			engclient_cmd(id, wpn)
		}
	}
}
//----------------------------------------------------------------------------------------------
public darth_loop()
{
	if ( !shModActive() ) return
	for ( new id = 1; id <= SH_MAXSLOTS; id++ ) {
		if ( gHasDarthMaulPowers[id] && is_user_alive(id) ) {
			// Let the server add the hps back since the # of max hps is controlled by it
			// I.E. Superman has more than 100 hps etc.
			shAddHPs(id, gHealPoints, gPlayerMaxHealth[id])
		}
	}
}
//----------------------------------------------------------------------------------------------
public darth_maxhealth()
{
	new id[6]
	new health[9]

	read_argv(1,id,5)
	read_argv(2,health,8)

	gPlayerMaxHealth[str_to_num(id)] = str_to_num(health)
}
//----------------------------------------------------------------------------------------------
public switchmodel(id)
{
	if ( !is_user_alive(id) ) return

	//If user is holding a shield do not change model, since we don't have one with a shield
	new v_mdl[32]
	Entvars_Get_String(id, EV_SZ_viewmodel, v_mdl, 31)
	if ( containi(v_mdl, "v_shield_") != -1 ) return

	new clip, ammo, wpnid = get_user_weapon(id, clip, ammo)
	if (wpnid == CSW_KNIFE) {
		// Weapon Model change thanks to [CCC]Taz-Devil
		Entvars_Set_String(id, EV_SZ_viewmodel, "models/shmod/darthmaul_knife.mdl")
		// Weapon Model change for 3rd person view
		Entvars_Set_String(id, EV_SZ_weaponmodel, "models/shmod/darthmaul_p_knife.mdl")
	}
}
//----------------------------------------------------------------------------------------------
public weaponChange(id)
{
	if ( !gHasDarthMaulPowers[id] || !shModActive() ) return

	new wpnid = read_data(2)

	if ( wpnid == CSW_KNIFE ) switchmodel(id)
}
//----------------------------------------------------------------------------------------------
public darth_damage(id)
{
	if ( !shModActive() || !is_user_alive(id) ) return

	new damage = read_data(2)
	new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)
	new headshot = bodypart == 1 ? 1 : 0

	if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return

	if ( gHasDarthMaulPowers[attacker] && weapon == CSW_KNIFE && is_user_alive(id) ) {
		// do extra damage
		new extraDamage = floatround(damage * get_cvar_float("darth_knifemult") - damage)
		if (extraDamage > 0) shExtraDamage(id, attacker, extraDamage, "knife", headshot)
	}
}
//----------------------------------------------------------------------------------------------