// Kraven! - Kraven the hunter from Spider-Man...

/* CVARS - copy and paste to shconfig.cfg

//Kraven
kraven_level 0
kraven_stuntime 3	// Time in seconds a user is stunned by Kraven (Default 3)
kraven_stunspeed 1	// Speed at which they can move during stun, 1-999 (Default 1)

*/

// Todo: stun pct chance or cooldown, since this is kinda bad as is right now..
// v1.1 - Temp Fix, added cvar for stun speed, and set it for only on gun damage - vittu 1-25-07

// Created by Dboy: Yodasha@hotmail.com, with help from gigazer.

#include <amxmodx>
#include <superheromod>

// VARIABLES
new HeroName[]="Kraven"
new bool:HasKraven[SH_MAXSLOTS+1]
new pCvarStunTime, pCvarStunSpeed
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Kraven", "1.1", "Dboy/gigazer")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("kraven_level", "0")
	pCvarStunTime = register_cvar("kraven_stuntime", "1")
	pCvarStunSpeed = register_cvar("kraven_stunspeed", "0.1")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(HeroName, "Tranquilizer Gun", "Stun your prey, with your tranquilizer bullets", false, "kraven_level")

	// INIT
	register_srvcmd("kraven_init", "kraven_init")
	shRegHeroInit(HeroName, "kraven_init")

	// EVENTS
	register_event("Damage", "kraven_damage", "b", "2!0")
}
//----------------------------------------------------------------------------------------------
public kraven_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2, temp, 5)
	new hasPowers = str_to_num(temp)

	HasKraven[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public kraven_damage(id)
{
	if ( !shModActive() || !is_user_alive(id) )
		return

	new weapon, attacker = get_user_attacker(id, weapon)

	if ( attacker <= 0 || attacker > SH_MAXSLOTS )
		return

	if ( HasKraven[attacker] && is_weapon_gun(weapon) && id != attacker && is_user_alive(id) )
	{
		// Set speed of stun first to be safe, this is proper way
		set_user_maxspeed(id, get_pcvar_float(pCvarStunSpeed))
		shStun(id, get_pcvar_num(pCvarStunTime))

		//should add a flash or maybe another effect to let them know they were stunned
	}
}
//----------------------------------------------------------------------------------------------
bool:is_weapon_gun(weapid)
{
	switch(weapid)
	{
		// 0 = worldspawn, aka. fall damage
		case 0, CSW_HEGRENADE, CSW_C4, CSW_KNIFE:
			return false

		default:
		{
			// Check against something else, make sure it is a weapon
			if ( 0 < weapid < 31 )
				return true
		}
	}

	return false
}
//----------------------------------------------------------------------------------------------