// PSYLOCKE - from the X-men. Betsy Braddock possesses many telepathic abilities.

/* CVARS - copy and paste to shconfig.cfg

//Psylocke
psylocke_level 2

*/

/*
* v1.2 - vittu - 6/22/05
*      - Minor code clean up.
*
* v1.1 - vittu - 3/29/05
*      - Fixed loop to actually check all enemies for the closeset one.
*      - Did usual clean up and removal of useless code.
*
*   Hero Created by StuD|MaN
*/

#include <amxmod>
#include <superheromod>

new gHeroName[]="Psylocke"
new bool:gHasPsylockePower[SH_MAXSLOTS+1]
new gClosestDist[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Psylocke", "1.2", "StuD|MaN")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("psylocke_level", "2")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Psychic Detection", "Recieve a Telepathic Warning when an Enemy is near.", false, "psylocke_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	//INIT
	register_srvcmd("psylocke_init", "psylocke_init")
	shRegHeroInit(gHeroName, "psylocke_init")

	//LOOP
	set_task(0.1, "psylocke_loop", 0, "", 0, "b")
}
//----------------------------------------------------------------------------------------------
public psylocke_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)

	gHasPsylockePower[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public psylocke_loop()
{
	if ( !shModActive() || !hasRoundStarted() ) return

	new distance, Origin[3], eOrigin[3]
	new players[SH_MAXSLOTS], pnum, id, enemy

	get_players(players, pnum, "a")

	for (new i = 0; i < pnum; i++) {
		id = players[i]
		if ( gHasPsylockePower[id] && is_user_alive(id) ) {

			gClosestDist[id] = 1182

			for (new e = 0; e < pnum; e++) {
				enemy = players[e]
				if( !is_user_alive(enemy) || get_user_team(id) == get_user_team(enemy) ) continue

				get_user_origin(id, Origin)

				get_user_origin(enemy, eOrigin)

				distance = get_distance(eOrigin, Origin)

				if (distance <= gClosestDist[id]){
					gClosestDist[id] = distance
				}
			}

			// get_distance() returns inches and 1 inch = 0.0254 meters
			if (gClosestDist[id] * 0.0254 <= 10.0) {
				set_hudmessage(255, 0, 0, 0.01, 0.27, 1, 6.0, 0.5, 0.1, 0.1, 155)
				show_hudmessage(id, "DANGER!  Enemy Detected Within 10 Meters!!!")
			}
			else if (gClosestDist[id] * 0.0254 <= 20.0) {
				set_hudmessage(255, 155, 0, 0.01, 0.27, 1, 6.0, 0.5, 0.1, 0.1, 155)
				show_hudmessage(id, "WARNING! Enemy Detected Within 20 Meters!!")
			}
			else if (gClosestDist[id] * 0.0254 <= 30.0) {
				set_hudmessage(255, 255, 255, 0.01, 0.27, 1, 6.0, 0.5, 0.1, 0.1, 155)
				show_hudmessage(id, "CAUTION!  Enemy Detected Within 30 Meters!")
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
