/****************************************************\
|*Seymour - Summon monsters!                        *|
|*Created By: Sam Tsuki                             *|
|*                                                  *|
|* Have Fun,                                        *|
|*           Sam Tsuki                              *|
\****************************************************/

/*shconfig.cfg Cvars:

//Seymour
seymour_level 5
seymour_radius 200		//Distance between aim and enemy
seymour_agrunt 1		//How many times can he summon an agrunt?
seymour_agrunt_cooldown 5
seymour_bigmomma 1		//How many times can he summon a bigmomma?
seymour_bigmomma_cooldown 10
seymour_bullsquid 2		//How many times can he summon a bullsquid?
seymour_bullsquid_cooldown 2
seymour_controller 1		//How many times can he summon a controller?
seymour_controller_cooldown 5
seymour_gargantua 1		//How many times can he summon a gargantua?
seymour_gargantua_cooldown 7
seymour_headcrab 3		//How many times can he summon a headcrab?
seymour_headcrab_cooldown 1
seymour_houndeye 2		//How many times can he summon a houndeye?
seymour_houndeye_cooldown 2
seymour_islave 2		//How many times can he summon a islave?
seymour_islave_cooldown 2
seymour_snark 5			//How many times can he summon a snark?
seymour_snark_cooldown 0
seymour_zombie 2		//How many times can he summon a zombie?
seymour_zombie_cooldown 3
*/

#include <amxmodx>
#include <fakemeta>
#include <superheromod>

// GLOBAL VARIABLES
new HeroName[] = "Seymour"
new bool:gHasSeymour[SH_MAXSLOTS+1]
new bool:NoTarget[SH_MAXSLOTS+1]
new AgrCool, BigCool, BulCool, ConCool, GarCool, HeaCool, HouCool, IslCool, SnaCool, ZomCool
new CvarRadius
new bool:roundfreeze
new round_delay
new monster_count[33][11]
new using_menu[33]
//--------------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Seymour", "1.0", "Sam Tsuki")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("seymour_level", "5")
	CvarRadius = register_cvar("seymour_radius", "200")
	register_cvar("seymour_agrunt", "1")
	AgrCool = register_cvar("seymour_agrunt_cooldown", "5")
	register_cvar("seymour_bigmomma", "1")
	BigCool = register_cvar("seymour_bigmomma_cooldown", "10")
	register_cvar("seymour_bullsquid", "2")
	BulCool = register_cvar("seymour_bullsquid_cooldown", "2")
	register_cvar("seymour_controller", "1")
	ConCool = register_cvar("seymour_controller_cooldown", "5")
	register_cvar("seymour_gargantua", "1")
	GarCool = register_cvar("seymour_gargantua_cooldown", "7")
	register_cvar("seymour_headcrab", "3")
	HeaCool = register_cvar("seymour_headcrab_cooldown", "1")
	register_cvar("seymour_houndeye", "2")
	HouCool = register_cvar("seymour_houndeye_cooldown", "2")
	register_cvar("seymour_islave", "2")
	IslCool = register_cvar("seymour_islave_cooldown", "2")
	register_cvar("seymour_snark", "5")
	SnaCool = register_cvar("seymour_snark_cooldown", "0")
	register_cvar("seymour_zombie", "2")
	ZomCool = register_cvar("seymour_zombie_cooldown", "3")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(HeroName, "Summon Monsters", "Summon a selected Monster on enemy closest to aim location with +power key", true, "seymour_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("seymour_init", "seymour_init")
	shRegHeroInit(HeroName, "seymour_init")
	
	//CLIENT QUICK COMMANDS
	register_clcmd("seymour_agrunt","seymour_summon")
	register_clcmd("seymour_bigmomma","seymour_summon")
	register_clcmd("seymour_bullsquid","seymour_summon")
	register_clcmd("seymour_controller","seymour_summon")
	register_clcmd("seymour_gargantua","seymour_summon")
	register_clcmd("seymour_headcrab","seymour_summon")
	register_clcmd("seymour_houndeye","seymour_summon")
	register_clcmd("seymour_islave","seymour_summon")
	register_clcmd("seymour_snark","seymour_summon")
	register_clcmd("seymour_zombie","seymour_summon")
	
	//EVENTS
	register_logevent("round_start", 2, "1=Round_Start")
	
	//SUMMON MENUS
	register_menucmd(register_menuid("Seymour Summon Menu 1"),1023,"action_menu_1")
	register_menucmd(register_menuid("Seymour Summon Menu 2"),1023,"action_menu_2")

	// KEY DOWN
	register_srvcmd("seymour_kd", "seymour_kd")
	shRegKeyDown(HeroName, "seymour_kd")

	// NEW SPAWN
	register_event("ResetHUD", "new_spawn", "b")
}
//--------------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_sound("ambience/port_suckin1.wav")
}
//--------------------------------------------------------------------------------------------------
public seymour_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2, temp, 5)
	new hasPowers = str_to_num(temp)

	gHasSeymour[id] = (hasPowers != 0)
}
//--------------------------------------------------------------------------------------------------
public new_spawn(id)
{
	gPlayerUltimateUsed[id] = false
	NoTarget[id] = false
}
//--------------------------------------------------------------------------------------------------
public seymour_kd()
{
	if ( !hasRoundStarted() )
		return

	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	if ( !is_user_alive(id) || !gHasSeymour[id] )
		return 

	if ( gPlayerUltimateUsed[id] )
	{
		playSoundDenySelect(id)
		return
	}

	seymour_menu_1(id)
}
//--------------------------------------------------------------------------------------------------
public seymour_menu_1(id) {
	new menu_body[320]
	new n = 0
	new len = 319

	if(!gHasSeymour[id] || !is_user_alive(id))
		return PLUGIN_HANDLED

	n += format( menu_body[n],len-n,"\ySeymour Summon Menu 1:^n\w^n")

	if ( monster_count[id][1] <= 0 ) {
		n += format( menu_body[n],len-n,"\r1. Alien Grunt: %d^n\w",monster_count[id][1])
	}
	else {
		n += format( menu_body[n],len-n,"1. Alien Grunt: %d^n",monster_count[id][1])
	}
	if ( monster_count[id][2] <= 0 ) {
		n += format( menu_body[n],len-n,"\r2. Big Momma: %d^n\w",monster_count[id][2])
	}
	else {
		n += format( menu_body[n],len-n,"2. Big Momma: %d^n",monster_count[id][2])
	}
	if ( monster_count[id][3] <= 0 ) {
		n += format( menu_body[n],len-n,"\r3. Bull Squid: %d^n\w",monster_count[id][3])
	}
	else {
		n += format( menu_body[n],len-n,"3. Bull Squid: %d^n",monster_count[id][3])
	}
	if ( monster_count[id][4] <= 0 ) {
		n += format( menu_body[n],len-n,"\r4. Controller: %d^n\w",monster_count[id][4])
	}
	else {
		n += format( menu_body[n],len-n,"4. Controller: %d^n",monster_count[id][4])
	}
	if ( monster_count[id][5] <= 0 ) {
		n += format( menu_body[n],len-n,"\r5. Gargantua: %d^n\w",monster_count[id][5])
	}
	else {
		n += format( menu_body[n],len-n,"5. Gargantua: %d^n",monster_count[id][5])
	}
	if ( monster_count[id][6] <= 0 ) {
		n += format( menu_body[n],len-n,"\r6. Head Crab: %d^n\w",monster_count[id][6])
	}
	else {
		n += format( menu_body[n],len-n,"6. Head Crab: %d^n",monster_count[id][6])
	}
	if ( monster_count[id][7] <= 0 ) {
		n += format( menu_body[n],len-n,"\r7. Hound Eye: %d^n\w",monster_count[id][7])
	}
	else {
		n += format( menu_body[n],len-n,"7. Hound Eye: %d^n",monster_count[id][7])
	}
	if ( monster_count[id][8] <= 0 ) {
		n += format( menu_body[n],len-n,"\r8. Slave: %d^n\y^n",monster_count[id][8])
	}
	else {
		n += format( menu_body[n],len-n,"8. Slave: %d^n\y^n",monster_count[id][8])
	}
	
	n += format( menu_body[n],len-n,"9. More^n")
	n += format( menu_body[n],len-n,"0. Exit")

	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9)

	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public seymour_menu_2(id) {
	new menu_body[320]
	new n = 0
	new len = 319

	if(!gHasSeymour[id] || !is_user_alive(id))
		return PLUGIN_HANDLED

	n += format( menu_body[n],len-n,"\ySeymour Summon Menu 2:^n\w^n")

	if ( monster_count[id][9] <= 0 ) {
		n += format( menu_body[n],len-n,"\r1. Snark: %d^n\w",monster_count[id][9])
	}
	else {
		n += format( menu_body[n],len-n,"1. Snark: %d^n",monster_count[id][9])
	}
	if ( monster_count[id][10] <= 0 ) {
		n += format( menu_body[n],len-n,"\r2. Zombie: %d^n\y^n",monster_count[id][10])
	}
	else {
		n += format( menu_body[n],len-n,"2. Zombie: %d^n\y^n",monster_count[id][10])
	}
	
	n += format( menu_body[n],len-n,"9. Back^n")
	n += format( menu_body[n],len-n,"0. Exit")

	new keys = (1<<0)|(1<<1)|(1<<8)|(1<<9)

	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public action_menu_1(id,key){
	using_menu[id] = 1

	if(!gHasSeymour[id] || !is_user_alive(id)) {
		using_menu[id] = 0
		return PLUGIN_HANDLED
	}

	if (roundfreeze && key != 10) {
		seymour_menu_1(id)
		return PLUGIN_HANDLED
	}


	switch(key){
		case 0: client_cmd(id,"seymour_agrunt")
		case 1: client_cmd(id,"seymour_bigmomma")
		case 2: client_cmd(id,"seymour_bullsquid")
		case 3: client_cmd(id,"seymour_controller")
		case 4: client_cmd(id,"seymour_gargantua")
		case 5: client_cmd(id,"seymour_headcrab")
		case 6: client_cmd(id,"seymour_houndeye")
		case 7: client_cmd(id,"seymour_islave")
		case 8: seymour_menu_2(id)
		case 9: using_menu[id] = 0
		default: seymour_menu_1(id)
	}

	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public action_menu_2(id,key){
	using_menu[id] = 1

	if(!gHasSeymour[id] || !is_user_alive(id)) {
		using_menu[id] = 0
		return PLUGIN_HANDLED
	}

	if (roundfreeze && key != 10) {
		seymour_menu_2(id)
		return PLUGIN_HANDLED
	}


	switch(key){
		case 0: client_cmd(id,"seymour_snark")
		case 1: client_cmd(id,"seymour_zombie")
		case 8: seymour_menu_1(id)
		case 9: using_menu[id] = 0
		default: seymour_menu_2(id)
	}

	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public seymour_summon(id)
{
	if ( !shModActive() || !is_user_alive(id) || !gHasSeymour[id] )
		return

	new distance, aimOrigin[3], vicOrigin[3], radius[SH_MAXSLOTS+1]
	new players[SH_MAXSLOTS], pnum, victim, targetid
	new idTeam = get_user_team(id)

	radius[id] = get_pcvar_num(CvarRadius)

	get_user_origin(id, aimOrigin, 3)

	get_players(players, pnum, "a")

	// Find the closest target to aim location, and make sure monster can spawn on them
	for (new i = 0; i < pnum; i++)
	{
		victim = players[i]

		if ( !is_user_alive(victim) || idTeam  == get_user_team(victim) )
			continue

		get_user_origin(victim, vicOrigin)

		distance = get_distance(vicOrigin, aimOrigin)

		if ( distance < radius[id] )
		{
			if ( pev(victim, pev_flags) & FL_NOTARGET )
			{
				NoTarget[id] = true
				continue
			}

			radius[id] = distance
			targetid = victim
		}
	}
	
	new Float:cooldown
	new cmd[32],mon[32],fulmon[32],icmd
	read_argv(0,cmd,31)

	if(equal(cmd,"seymour_agrunt")) {
		icmd = 1
		mon = "agrunt"
		fulmon = "Alien Grunt"
		cooldown = get_pcvar_float(AgrCool)
	}
	else if(equal(cmd,"seymour_bigmomma")) {
		icmd = 2
		mon = "bigmomma"
		fulmon = "Big Momma"
		cooldown = get_pcvar_float(BigCool)
	}
	else if(equal(cmd,"seymour_bullsquid")) {
		icmd = 3
		mon = "bullsquid"
		fulmon = "Bull Squid"
		cooldown = get_pcvar_float(BulCool)
	}
	else if(equal(cmd,"seymour_controller")) {
		icmd = 4
		mon = "controller"
		fulmon = "Controller"
		cooldown = get_pcvar_float(ConCool)
	}
	else if(equal(cmd,"seymour_gargantua")) {
		icmd = 5
		mon = "gargantua"
		fulmon = "Gargantua"
		cooldown = get_pcvar_float(GarCool)
	}
	else if(equal(cmd,"seymour_headcrab")) {
		icmd = 6
		mon = "headcrab"
		fulmon = "Head Crab"
		cooldown = get_pcvar_float(HeaCool)
	}
	else if(equal(cmd,"seymour_houndeye")) {
		icmd = 7
		mon = "houndeye"
		fulmon = "Hound Eye"
		cooldown = get_pcvar_float(HouCool)
	}
	else if(equal(cmd,"seymour_islave")) {
		icmd = 8
		mon = "islave"
		fulmon = "Slave"
		cooldown = get_pcvar_float(IslCool)
	}
	else if(equal(cmd,"seymour_snark")) {
		icmd = 9
		mon = "snark"
		fulmon = "Snark"
		cooldown = get_pcvar_float(SnaCool)
	}
	else if(equal(cmd,"seymour_zombie")) {
		icmd = 10
		mon = "zombie"
		fulmon = "Zombie"
		cooldown = get_pcvar_float(ZomCool)
	}
	
	if( monster_count[id][icmd] <= 0 ){
		switch(icmd){
			case 1: client_print(id,print_chat,"[SH](Seymour) You have no more Alien Grunts.")
			case 2: client_print(id,print_chat,"[SH](Seymour) You have no more Big Mommas.")
			case 3: client_print(id,print_chat,"[SH](Seymour) You have no more Bull Squid.")
			case 4: client_print(id,print_chat,"[SH](Seymour) You have no more Controllers.")
			case 5: client_print(id,print_chat,"[SH](Seymour) You have no more Gargantuas.")
			case 6: client_print(id,print_chat,"[SH](Seymour) You have no more Head Crabs.")
			case 7: client_print(id,print_chat,"[SH](Seymour) You have no more Hound Eyes.")
			case 8: client_print(id,print_chat,"[SH](Seymour) You have no more Slaves.")
			case 9: client_print(id,print_chat,"[SH](Seymour) You have no more Snarks.")
			case 10: client_print(id,print_chat,"[SH](Seymour) You have no more Zombies.")
		}
		playSoundDenySelect(id)
		return
	}

	if ( targetid && is_user_alive(targetid) )
	{
		emit_sound(id, CHAN_STATIC, "ambience/port_suckin1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		emit_sound(targetid, CHAN_STATIC, "ambience/port_suckin1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		new targetName[32]
		get_user_name(targetid, targetName, 31)
		client_print(id, print_chat, "[SH](%s) Summoned Monster '%s' on %s", HeroName, fulmon, targetName)
		
		monster_count[id][icmd] -= 1

		server_cmd("monster %s #%i", mon, targetid)

		if ( cooldown > 0.0 )
			ultimateTimer(id, cooldown)

		NoTarget[id] = false
	}
	else
	{
		switch(NoTarget[id])
		{
			case false:
			{
				client_print(id, print_center, "[SH](%s) No target found", HeroName)
				playSoundDenySelect(id)
			}

			case true:
			{
				client_print(id, print_center, "[SH](%s) Unable to spawn monster on victim", HeroName)
				NoTarget[id] = false
				playSoundDenySelect(id)
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------
public round_start(){
	roundfreeze = false

	if (get_cvar_num("seymour_spawndelay") && !round_delay) {
		round_delay = 1
		set_task(15.0,"roundstart_delay")
	}

	for (new i = 1; i <= get_maxplayers(); i++) {
		monster_count[i][1] = get_cvar_num("seymour_agrunt")
		monster_count[i][2] = get_cvar_num("seymour_bigmomma")
		monster_count[i][3] = get_cvar_num("seymour_bullsquid")
		monster_count[i][4] = get_cvar_num("seymour_controller")
		monster_count[i][5] = get_cvar_num("seymour_gargantua")
		monster_count[i][6] = get_cvar_num("seymour_headcrab")
		monster_count[i][7] = get_cvar_num("seymour_houndeye")
		monster_count[i][8] = get_cvar_num("seymour_islave")
		monster_count[i][9] = get_cvar_num("seymour_snark")
		monster_count[i][10] = get_cvar_num("seymour_zombie")
	}
	
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public client_connect(id)
{
	gHasSeymour[id] = false
	NoTarget[id] = false
	
	monster_count[id][1] = get_cvar_num("seymour_agrunt")
	monster_count[id][2] = get_cvar_num("seymour_bigmomma")
	monster_count[id][3] = get_cvar_num("seymour_bullsquid")
	monster_count[id][4] = get_cvar_num("seymour_controller")
	monster_count[id][5] = get_cvar_num("seymour_gargantua")
	monster_count[id][6] = get_cvar_num("seymour_headcrab")
	monster_count[id][7] = get_cvar_num("seymour_houndeye")
	monster_count[id][8] = get_cvar_num("seymour_islave")
	monster_count[id][9] = get_cvar_num("seymour_snark")
	monster_count[id][10] = get_cvar_num("seymour_zombie")
}
//--------------------------------------------------------------------------------------------------
