// THE TICK! - from The Tick, The big blue arachnid who is nigh invunerable.
// Based on v3x's "No fall damage" 0.2, off of leakgfhp's method.

/* CVARS - copy and paste to shconfig.cfg

//The Tick
thetick_level 0

*/

/*
* v1.2 - vittu - 7/19/06
*       - Converted to fakemeta.
*
* v1.1 - vittu - 3/31/06
*       - Small code changes.
*
*/

#include <amxmodx>
#include <fakemeta>
#include <superheromod>

// GLOBAL VARIABLES
new HeroName[] = "The Tick"
new bool:HasTheTick[SH_MAXSLOTS+1]
new bool:Falling[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO The Tick", "1.2", "vittu")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("thetick_level", "0")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(HeroName, "No Fall Damage", "SPOOOON! Take no damage from falling", false, "thetick_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	register_srvcmd("thetick_init", "thetick_init")
	shRegHeroInit(HeroName, "thetick_init")

	// FORWARDS
	register_forward(FM_PlayerPreThink, "thetick_prethink")
	register_forward(FM_PlayerPostThink, "thetick_postthink")
}
//----------------------------------------------------------------------------------------------
public thetick_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2, temp, 5)
	new hasPowers = str_to_num(temp)

	HasTheTick[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public thetick_prethink(id)
{
	if ( shModActive() && is_user_alive(id) && HasTheTick[id] )
	{
		new Float:fallVelocity
		pev(id, pev_flFallVelocity, fallVelocity)
		if ( fallVelocity >= 350.0 )
			Falling[id] = true
	}
}
//----------------------------------------------------------------------------------------------
public thetick_postthink(id)
{
	if ( shModActive() && is_user_alive(id) && HasTheTick[id] )
	{
		if ( Falling[id] )
		{
			if ( !get_user_godmode(id) )
				set_pev(id, pev_watertype, CONTENTS_WATER)

			Falling[id] = false
		}
	}
}
//----------------------------------------------------------------------------------------------