//THIEF! He steals your money.

/* CVARS - copy and paste to shconfig.cfg

//Thief
thief_level 4
thief_cashperlev 100	//How much money he steals per hit per his level (Default 100)

*/

// v1.2 - vittu - 12/25/05 - Cleaned up code.

#include <amxmod>
#include <superheromod>

#if defined AMX98
	#include <xtrafun>
#endif

// GLOBAL VARIABLES
new g_heroName[]="Thief"
new bool:g_hasThiefPowers[SH_MAXSLOTS+1]
new g_playerLevels[SH_MAXSLOTS+1]
new Float:g_cashSteal
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Thief", "1.2", "AssKicR")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("thief_level", "4")
	register_cvar("thief_cashperlev", "100")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(g_heroName, "Pick Pocket", "Steal money from people by knifeing them", false, "thief_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("thief_init", "thief_init")
	shRegHeroInit(g_heroName, "thief_init")

	// LEVELS
	register_srvcmd("thief_levels", "thief_levels")
	shRegLevels(g_heroName, "thief_levels")

	// DAMAGE
	register_event("Damage", "thief_damage", "b", "2!0")

	// Set some variables
	g_cashSteal = get_cvar_float("thief_cashperlev")
}
//----------------------------------------------------------------------------------------------
public thief_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)

	g_hasThiefPowers[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public thief_levels()
{
	new id[5]
	new lev[5]

	read_argv(1, id, 4)
	read_argv(2, lev, 4)

	g_playerLevels[str_to_num(id)] = str_to_num(lev)
}
//----------------------------------------------------------------------------------------------
public thief_damage(id)
{
	if ( !shModActive() || !is_user_alive(id) ) return

	new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)

	if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return

	if ( g_hasThiefPowers[attacker] && is_user_alive(id) && attacker!=id && weapon == CSW_KNIFE ) {
		// Steal some cash
		new cash = floatround(g_cashSteal * g_playerLevels[attacker])
		new moneyid = get_user_money(id)
		new moneyattacker = get_user_money(attacker)
		new name[33]

		get_user_name(id, name, 32)

		if ( moneyid < cash ) {
			client_print(attacker, print_center, "[SH](Thief) %s doesn't have that much money", name)
			return
		}

		if ( (moneyattacker+cash) > 16000 ) {
			client_print(attacker, print_center, "[SH](Thief) You can't carry that much money")
			return
		}

		set_user_money(id, moneyid-cash)
		set_user_money(attacker, moneyattacker+cash)

		client_print(attacker, print_center, "[SH](Thief) You stole %i $ from %s", cash, name)
	}
}
//----------------------------------------------------------------------------------------------