// Zero G - Set people on gravity 0 when you shoot them.

/* CVARS - copy and paste to shconfig.cfg

//Zero G
zerog_level 0
zerog_cooldown 600		// # of second before you can set gravity on people again.
zerog_time 30.0		// # of second attacker has no gravity
*/

//Register Plugin Events
#define AUTHOR Sir-LaggAlot
#define VERSION 1.1

//Library
#include <amxmod>
#include <fun>
#include <superheromod>

// VARIABLES
new gHeroName[]="Zero G"
new gHasZeroGPower[SH_MAXSLOTS+1]
new bool:gZeroGrav[SH_MAXSLOTS+1]
new Float:grav[SH_MAXSLOTS+1]

public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Zero G", "VERSION", "AUTHOR")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("zerog_level", "0" )
	register_cvar("zerog_cooldown", "600" )
	register_cvar("zerog_time", "30.0" )

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Set 0 Gravity on Enemy", "Set gravity 0 on your opponent when you shoot them.", false, "zerog_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	register_srvcmd("zerog_init", "zerog_init")
	shRegHeroInit(gHeroName, "zerog_init")

	register_event("ResetHUD","newSpawn","b")
	register_event("Damage", "zerog_damage", "b", "2!0")
}

public zerog_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id=str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has Zero G
	read_argv(2,temp,5)
	new hasPowers=str_to_num(temp)

	gHasZeroGPower[id] = (hasPowers != 0)
}

public newSpawn(id) 
{ 
	if (!shModActive()) return 
 
	gPlayerUltimateUsed[id] = false 
 
	if(gZeroGrav[id]) { 
	gZeroGrav[id] = false 
	remove_task(id) 
	set_user_gravity(id, grav[id]) 
	} 
}

public zerog_damage(id)
{
	if (!shModActive() || !is_user_alive(id)) return

	new weapon, bodypart, attacker = get_user_attacker(id,weapon,bodypart)

	if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return

	if (!gHasZeroGPower[attacker] || gPlayerUltimateUsed[attacker] ) return

	if ( is_user_alive(attacker) && id != attacker ) {

		grav[id] = Float:get_user_gravity(id)

		gZeroGrav[id] = true

		client_print(id,print_chat,"[SH] You have zero gravity" )
		set_task(0.1,"zerog_loop", id, "", 0, "b")
		set_task(get_cvar_float("zerog_time"),"zerog_fin", id)

		ultimateTimer(attacker, get_cvar_num("zerog_cooldown") * 1.0)
	}
}
public zerog_loop(id)
{
	if(is_user_alive(id) && gZeroGrav[id]) set_user_gravity(id, 0.0)
}
public zerog_fin(id)
{
	if(gZeroGrav[id]){
	remove_task(id)
	gZeroGrav[id] = false
	set_user_gravity(id, grav[id])
	client_print(id,print_chat,"[SH] Your gravity has restored to normal")
	}
}